## Preseed Configurator - A graphical preseed file generator
## Copyright (C) 2009 Oriol Matavacas Rodriguez
## Based on GPL project "Kickstart Configurator v2.5" from RedHat,Brent Fox and Tammy Fox

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import string

class KickstartData:
    def __init__(self):
        self.lang = None
        self.langsupport = None
        self.defaultLang = None
        self.keyboard = None
        self.timezone = None
        self.rootpw = None
        self.user = None
        self.reboot = None
        self.install = None
        self.interactive = None
        self.text = None
        self.cdrom = None
        self.harddrive = None
        self.nfs = None
        self.url = None
        self.bootloader = None
        self.clearpart = None
        self.networkList = []
#        self.auth = None
#        self.firewall = None
#        self.skipx = None
#        self.package = None
        self.everything = False
        self.pre = None
        self.post = None
        self.upgrade = None
        self.xconfig = None
        self.firstboot = None
        self.partList = []
        self.raidList = []
#        self.packageGroupList = []
#        self.individualPackageList = []
        self.preLine = None
        self.preList = []
        self.postLine = None
        self.postList = []
        self.platform = "x86"
        self.OEM_ = None
        self.packages2 = None
        self.Mirrors = None
        self.SecMirrors = None
        self.additional = None
        self.NTP = None
        self.Popularity = None
        self.Unnautenticated = None

    def setUnnautenticated(self,args):
        self.Unnautenticated = string.join(args, "")

    def getUnnautenticated(self):
        return self.Unnautenticated

    def setPopularity(self,args):
        self.Popularity = string.join(args, "")

    def getPopularity(self):
        return self.Popularity

    def setNTP(self,args):
        self.NTP = string.join(args," ")

    def getNTP(self):
        return self.NTP

    def setOEM(self,args):
        if args == None:
            self.OEM_ = None
        else:
            self.OEM_ = "OEM"

    def getOEM(self):
        return self.OEM_

    def setLang(self, args):
        self.lang = args[0]

    def getLang(self):
        return self.lang

    def setLangSupport(self, args):
        list = []

        if args == None:
            self.langsupport = []
            return

        for item in args:
            if item[:10] == "--default=":
                self.setDefaultLang(item[10:])
            else:
                list.append(item)

        self.langsupport = list

    def getLangSupport(self):
        return self.langsupport

    def setDefaultLang(self, default):
        self.defaultLang = default

    def getDefaultLang(self):
        return self.defaultLang

    def setKeyboard(self, args):
        self.keyboard = args[0]

    def getKeyboard(self):
        return self.keyboard

    def setText(self, args):
        if args == None:
            self.text = None
        else:
            self.text = "BOOTPARAMETER DEBIAN_FRONTEND=text"

    def getText(self):
        return self.text

    def setTimezone(self, args):
        self.timezone = args[-1]

    def getTimezone(self):
        return self.timezone

    def setRootPw(self, args):
        if args == None:
            self.rootpw = None
        else:
            self.rootpw = string.join(args, " ")

    def getRootPw(self):
        return self.rootpw

    def setUser(self, args):
        if args == None:
            self.user = None
        else:
            self.user = string.join(args, " ")

    def getUser(self):
        return self.user
###################
# MaTa
    def setUserOpts(self, args):
        if args == None:
            self.UserOpts = None
        else:
            self.UserOpts = string.join(args," ")

    def getUserOpts(self):
        return self.UserOpts

    def sethost_dom(self,args):
        if args == None:
            self.host_dom2 = None
        else:
            self.host_dom2 = string.join(args, "")

    def gethost_dom(self):
        return self.host_dom2
######
    def setReboot(self, args):
        if args == None:
            self.reboot = None
        else:
            self.reboot = "d-i finish-install/reboot_in_progress note"

    def getReboot(self):
        return self.reboot

#    def setInstall(self, args):
#        if args == None:
#            self.install = None
#        else:
#            self.install = "install"
#            self.setUpgrade(None)
#
#    def getInstall(self):
#        return self.install

    def setInteractive(self, args):
        if args == None:
            self.interactive = None
        else:
            self.interactive = "BOOTPARAMETER preseed/interactive=true"

    def getInteractive(self):
        return self.interactive

    def setCheck(self,args):
        if args == None:
            self.check = None
        else:
            self.check = "d-i cdrom-checker/start boolean true"

    def getCheck(self):
        return self.check

    def setNextCD(self,args):
        if args == None:
            self.nextcd = None
        else:
            self.nextcd = "d-i cdrom-checker/nextcd boolean true"

    def getNextCD(self):
        return self.nextcd
###############################
    def setEject(self,args):
        if args == None:
            self.eject = None
        else:
            self.eject = "#Prevent for ejecting CDROM" + "\nd-i cdrom-detect/eject boolean false"

    def getEject(self):
        return self.eject

    def setMKShutdown(self,args):
        if args == None:
            self.MKShutdown = None
        else:
            self.MKShutdown = "#Make the installer shutdown when finished" + "\nd-i debian-installer/exit/halt boolean true"

    def getMKShutdown(self):
        return self.MKShutdown

#############################

#    def setCdrom(self, args):
#        if args == None:
#            self.cdrom = None
#        else:
#            self.cdrom = "cdrom"
#            self.setNfs(None)
#            self.setUrl(None)
#            self.setHardDrive(None)
#
#    def getCdrom(self):
#        return self.cdrom
#
#    def setHardDrive(self, args):
#        if args == None:
#            self.harddrive = None
#        else:
#            self.harddrive = args
#            self.setNfs(None)
#            self.setUrl(None)
#            self.setCdrom(None)
#
#    def getHardDrive(self):
#        return self.harddrive
#
#    def setNfs(self, args):
#        if args == None:
#            self.nfs = None
#        else:
#            self.nfs = args
#            self.setHardDrive(None)
#            self.setUrl(None)
#            self.setCdrom(None)
#
#    def getNfs(self):
#        return self.nfs
#
#    def setUrl(self, args):
#        if args == None:
#            self.url = None
#        else:
#            self.url = args[1]
#            self.setNfs(None)
#            self.setHardDrive(None)
#            self.setCdrom(None)
#
#    def getUrl(self):
#        return self.url

    def setBootloader(self, args):
        self.bootloader = args

    def getBootloader(self):
        return self.bootloader

    def setClearPart(self, args):
        if args == None:
            self.clearpart = None
        else:
            self.clearpart = args

    def getClearPart(self):
        return self.clearpart

    def setNetwork(self, args):
        self.networkList.append(args)

    def getNetwork(self):
        return self.networkList

    def clearNetwork(self):
        self.networkList = []

#    def setAuth(self, args):
#        self.auth = args
#
#    def getAuth(self):
#        return self.auth

#    def setFirewall(self, args):
#        self.firewall = args
#
#    def getFirewall(self):
#        return self.firewall

#    def setSkipX(self, args):
#        if args == None:
#            self.skipx = None
#        else:
#            self.skipx = "skipx"
#
#    def getSkipX(self):
#        return self.skipx

#    def setUpgrade(self, args):
#        if args == None:
#            self.upgrade = None
#        else:
#            self.upgrade = "upgrade"
#            senstall(None)
#
#    def getUpgrade(self):
#        return self.upgrade

    def definePartition(self, args):
        self.partList.append(args)

    def getPartitions(self):
        return self.partList

    def clearPartList(self):
        self.partList = []

    def defineRaid(self, args):
        self.raidList.append(args)

    def getRaid(self):
        return self.raidList

    def clearRaidList(self):
        self.raidList = []

    def setXconfig(self, args):
        if args == None:
            self.xconfig = None
        else:
            self.xconfig = args

    def getXconfig(self):
        return self.xconfig

    def setFirstboot(self, args):
        if args == None:
            self.firstboot = None
        else:
            self.firstboot = args[0]

    def getFirstboot(self):
        return self.firstboot

    def setEverything(self, args):
        self.everything = args

    def getEverything(self):
        return self.everything

#    def setPackageGroupList(self, args):
#        self.packageGroupList = args
#
#    def getPackageGroupList(self):
#        return self.packageGroupList

#    def setIndividualPackageList(self, args):
#        self.individualPackageList = args
#
#    def getIndividualPackageList(self):
#        return self.individualPackageList

    def setPreLine(self, args):
        if args == None:
            self.preLine = None
        else:
            self.preLine = args

    def getPreLine(self):
        return self.preLine

    def setPreList(self, args):
        self.preList = args

    def getPreList(self):
        return self.preList

    def setPostLine(self, args):
        if args == None:
            self.postLine = None
        else:
            self.postLine = args

    def getPostLine(self):
        return self.postLine

    def setPostList(self, args):
        self.postList = args

    def getPostList(self):
        return self.postList

    def setPlatform(self, platform):
        self.platform = platform

    def getPlatform(self):
        return self.platform

    def setpackages2(self, args):
        self.packages2 = args

    def getpackages2(self):
        return self.packages2

    def setMirrors(self,args):
        self.Mirrors = args

    def getMirrors(self):
        return self.Mirrors

    def setSecMirrors(self,args):
        self.SecMirrors = args

    def getSecMirrors(self):
        return self.SecMirrors

    def setadditional(self,args):
        self.additional = args

    def getadditional(self):
        return self.additional

    def getAll(self):
        file = []

        file.append("#Generated by Preseed (Beta) Configurator")
        file.append("#platform=%s\n" % self.platform)

        file.append("##System language and Language modules to install")
        if len(self.langsupport) == 0:
            file.append("d-i debian-installer/locale string %s" % self.getLang())
            file.append("d-i pkgsel/language-packs string " + self.getDefaultLang())

        elif len(self.langsupport) == 1:
            if self.getDefaultLang() in self.getLangSupport():
                file.append("d-i debian-installer/locale string " + self.langsupport[0] + \
                             "\nd-i pkgsel/language-packs string " + self.langsupport[0])

            else:
                file.append("d-i debian-installer/locale string " + self.getDefaultLang() + \
                             "\nd-i pkgsel/language-packs string " + self.getDefaultLang() + " " + self.langsupport[0])

        elif len(self.langsupport) > 1:
            if self.getDefaultLang() in self.getLangSupport():
                self.langsupport.remove(self.getDefaultLang())

            list = string.join(self.langsupport, " ")
            file.append("d-i debian-installer/locale string " + self.getDefaultLang() + \
                        "\nd-i pkgsel/language-packs string  " + self.getDefaultLang() + " " + list)

        file.append("d-i console-keymaps-at/keymap select " + self.getKeyboard())


        if self.getNetwork():
            file.append("\n#Network information")
            for line in self.networkList:
                file.append("" + string.join(line,""))

        if self.gethost_dom():
            file.append("#Hostname and domain name")
            file.append(self.gethost_dom())

        if self.getMirrors():
            file.append("\n#Packages mirror information")
            file.append(string.join(self.getMirrors(), " "))

        if self.getSecMirrors():
            file.append("#Security mirror information")
            file.append(string.join(self.getSecMirrors(), " "))

        if self.getTimezone():
            file.append("\n#System timezone")
            file.append("" + self.getTimezone())

        if self.getNTP():
            file.append("#Clock NTP Synchronize")
            file.append(self.getNTP())

        if self.getClearPart():
            file.append("" + string.join(self.getClearPart(), " "))

        if self.getPartitions() != []:
            file.append("#Personalized recipe information")
            file.append("d-i partman-auto/expert_recipe string \\")
            for line in self.getPartitions():
                tokens = string.split(string.strip(line[0]))
                if tokens[0] == "raid":
                    file.append(string.join(line, " "))
                else:
                    file.append(string.join(line, " "))
        file.append("d-i partman/confirm_write_new_label boolean true" + \
                    "\nd-i partman/choose_partition select Finish partitioning and write changes to disk" + \
                    "\nd-i partman/confirm boolean true")

        if self.getUnnautenticated():
            file.append(self.getUnnautenticated())

        file.append("\n##Users accounts information" + "\n#Root account")
        if self.getRootPw():
            file.append("d-i passwd/root-password" + self.getRootPw())
        else:
            file.append("d-i passwd/root-login boolean false")

        if self.getUser():
            file.append("#Initial user account")
            file.append("" + self.getUser())
        else:
            if self.getOEM():
                file.append("#Initial user account for OEM mode (will be overided on reboot)")
                file.append("d-i passwd/user-fullname string OEM" + \
                        "\nd-i passwd/username string oem" + \
                        "\nd-i passwd/user-password password password" + \
                        "\nd-i passwd/user-password-again password password")

            else:
                file.append("#Initial user account")
                file.append("d-i passwd/make-user boolean false")

        if self.getUserOpts():
            file.append("#User options" + self.getUserOpts())

        if self.getpackages2():
            file.append("\n#Package selections")
            file.append(string.join(self.getpackages2(), " "))

        if self.getPopularity():
            file.append("\n#Popularity contest")
            file.append(self.getPopularity())

        if self.getBootloader():
            file.append("\n#System bootloader configuration")
            file.append(string.join(self.getBootloader(), " "))

        file.append("\n##Additional Options")
        if self.getReboot():
            file.append("#Reboot after installation")
            file.append(self.getReboot())

        if self.getEject():
            file.append(self.getEject())

        if self.getMKShutdown():
            file.append(self.getMKShutdown())

        if self.getCheck():
            file.append("#Check media CD before installation")
            file.append(self.getCheck())

        if self.getadditional():
            file.append(self.getadditional())

        if self.getNextCD():
            file.append("#Check for the next CD")
            file.append(self.getNextCD())

        if self.getXconfig():
            file.append("\n##X Window System configuration information")
            file.append(string.join(self.getXconfig(), " "))




        self.any_advanced = False
        if self.getPreLine():
            file.append("\n## Advanced options")
            self.any_advanced = True
            file.append("#early_command script" + \
                        "\nd-i preseed/early_command string \\" + self.getPreLine())

            if self.getPreList != []:
                for line in self.getPreList():
                    file.append(line)
        else:
            file.append("\n## Advanced options")
            self.any_advanced = True
            if self.getPreList() != []:
                file.append("#early_command script" + \
                            "\nd-i preseed/early_command string \\")
                for line in self.getPreList():
                    file.append(line)

        if self.getPostLine():
            if not self.any_advanced:
                file.append("\n## Advanced options")
                self.any_advanced = True
            file.append("#late_command script" + \
                        "\nd-i preseed/late_command string" + self.getPostLine())

            if self.getPostList != []:
                for line in self.getPostList():
                    file.append(line)

        else:
            if not self.any_advanced:
                file.append("\n## Advanced options")
                self.any_advanced = True
            if self.getPostList() != []:
                file.append("#late_command script" + \
                            "\nd-i preseed/late_command string \\")
                for line in self.getPostList():
                    file.append(line)

        # Prova 1:
        #                    file.append(string.join(`line` + "\\" + "\n",""))
        # Prova 2
        #                    temp = ""
        #                    temp = line
        #                    temp = temp + "\\\n"
        #                    file.append(`temp`)
        # Falta provar : http://effbot.org/zone/python-list.htm

# For testing only
        file.append("\n\n\n\n\n\n")






























        if self.getText():
            file.append("#Use text mode install")
            file.append(self.getText())

        if self.getInteractive():
            file.append("#Use interactive kickstart installation method")
            file.append(self.getInteractive())










#        if self.getInstall():
#            file.append("#Install OS instead of upgrade")
#            file.append(self.getInstall())
#
#        elif self.getUpgrade():
#            file.append("#Upgrade existing installation")
#            file.append(self.getUpgrade())
#
#        if self.getCdrom():
#            file.append("#Use CDROM installation media")
#            file.append(self.getCdrom())
#
#        elif self.getNfs():
#            file.append("#Use NFS installation media")
#            file.append("nfs " +  string.join(self.getNfs()," "))
#
#        elif self.getHardDrive():
#            file.append("#Use hard drive installation media")
#            file.append("harddrive " + self.getHardDrive())
#
#        elif self.getUrl():
#            file.append("#Use Web installation")
#            file.append("url --url " + self.getUrl())
#            pass

#        if self.getAuth():
#            file.append("#System authorization infomation")
#            file.append("auth " + string.join(self.getAuth(), " "))

#        if self.getFirewall():
#            file.append("#Firewall configuration")
#            file.append("firewall " + string.join(self.getFirewall(), " "))



        if self.getFirstboot():
            file.append("#Run the Setup Agent on first boot")
            file.append("firstboot " + self.getFirstboot())

#        if self.getSkipX():
#            file.append("#Do not configure the X Window System")
#            file.append("skipx")

#        if self.getEverything() == True:
#            file.append("#Package install information")
#            file.append("%packages\n@everything")
#        elif self.getPackageGroupList() != [] or self.getIndividualPackageList() != []:
#            file.append("#Package install information")
#            file.append("%packages")
#
#            if self.getPackageGroupList() != []:
#                for package in self.getPackageGroupList():
#                    file.append("@ %s" % package)
#
#            if self.getIndividualPackageList() != []:
#                for package in self.getIndividualPackageList():
#                    file.append(package)



        return file

    def printData(self):
        file = self.getAll()
        for line in file:
            print line
