## Preseed Configurator - A graphical preseed file generator
## Copyright (C) 2009 Oriol Matavacas Rodriguez
## Based on GPL project "Kickstart Configurator v2.5" from RedHat,Brent Fox and Tammy Fox

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


import gtk
import gtk.glade
import gobject
import string
import os
import random
import crypt
import getopt
import shlex

#import mouse
#from hardwareLists import langDict, layoutDict, variantDict

import kickstartGui

##
## I18N
##
import gettext
domain = 'system-config-kickstart'
gettext.bindtextdomain(domain, '/usr/share/locale')
gettext.textdomain(domain)
_ = gettext.gettext
gtk.glade.bindtextdomain(domain)

class packages2:

    def __init__(self, xml, notebook, kickstartData):
        self.notebook = notebook
        self.kickstartData = kickstartData
        self.xml = xml

        self.RP_NonFree = xml.get_widget("RP_NonFree")
        self.RP_Contrib = xml.get_widget("RP_Contrib")
        self.RP_Main = xml.get_widget("RP_Main")
        self.RP_Restricted = xml.get_widget("RP_Restricted")
        self.RP_Universe = xml.get_widget("RP_Universe")
        self.RP_Backports = xml.get_widget("RP_Backports")
        self.Standard = xml.get_widget("Standard")
        self.FileServer = xml.get_widget("FileServer")
        self.MailServer = xml.get_widget("MailServer")
        self.SQLDatabase = xml.get_widget("SQLDatabase")
        self.DNS = xml.get_widget("DNS")
        self.Laptop = xml.get_widget("Laptop")
        self.PrintServer = xml.get_widget("PrintServer")
        self.WebServer = xml.get_widget("WebServer")
        self.LAMP = xml.get_widget("LAMP")
        self.Gnome_CheckButton = xml.get_widget("Gnome_CheckButton")
        self.KDE_CheckButton = xml.get_widget("KDE_CheckButton")
        self.Xfce_CheckButton = xml.get_widget("Xfce_CheckButton")
        self.AdPackages_Entry = xml.get_widget("AdPackages_Entry")
        self.AllowUnnautenticated_CheckButton = xml.get_widget("AllowUnnautenticated_CheckButton")
        self.config_x_button = xml.get_widget("config_x_button")
        self.xconfig_notebook = xml.get_widget("xconfig_notebook")
# Mirror buttons and text
        self.mirror_list = xml.get_widget("mirror_list")
        self.mirror_manually = xml.get_widget("mirror_manually")
        self.mirror_hostname = xml.get_widget("mirror_hostname")
        self.mirror_directory = xml.get_widget("mirror_directory")
        self.mirror_suite = xml.get_widget("mirror_suite")
        self.mirror_proxy = xml.get_widget("mirror_proxy")
        self.src_button = xml.get_widget("src_button")
        self.no_mirror = xml.get_widget("no_mirror")
        self.mirror_random = xml.get_widget("mirror_random")
        self.NO_Update_button = xml.get_widget("NO_Update_button")
# Mirrors list
        self.repo_combo = xml.get_widget("repo_combo")
        self.repo_list = [_("ftp.au.debian.org"),_("ftp.at.debian.org"),_("ftp.be.debian.org"),_("ftp.br.debian.org"),_("ftp.bg.debian.org"),_("ftp.ca.debian.org"),_("ftp.cl.debian.org"),_("ftp.hr.debian.org"),_("ftp.cz.debian.org"),_("ftp.dk.debian.org"),_("ftp.ee.debian.org"),_("ftp.fi.debian.org"),_("ftp.fr.debian.org"),_("ftp2.fr.debian.org"),_("ftp.de.debian.org"),_("ftp2.de.debian.org"),_("ftp.uk.debian.org"),_("ftp.gr.debian.org"),_("ftp.hk.debian.org"),_("ftp.hu.debian.org"),_("ftp.is.debian.org"),_("ftp.ie.debian.org"),_("ftp.it.debian.org"),_("ftp.jp.debian.org"),_("ftp2.jp.debian.org"),_("ftp.kr.debian.org"),_("ftp.mx.debian.org"),_("ftp.nl.debian.org"),_("ftp.nz.debian.org"),_("ftp.no.debian.org"),_("ftp.pl.debian.org"),_("ftp.pt.debian.org"),_("ftp.ro.debian.org"),_("ftp.ru.debian.org"),_("ftp.sk.debian.org"),_("ftp.si.debian.org"),_("ftp.es.debian.org"),_("ftp.se.debian.org"),_("ftp.ch.debian.org"),_("ftp.tw.debian.org"),_("ftp.tr.debian.org"),_("ftp.ua.debian.org"),_("ftp.us.debian.org")]
        self.repo_combo.entry.connect("changed", self.repolistChanged)
        self.repo_combo.set_popdown_strings(self.repo_list)
# Mirrors Manually
        self.mirror_hostname.connect("changed", self.repomanualChanged)
        self.mirror_directory.connect("changed", self.repomanualChanged)
        self.mirror_suite.connect("changed", self.repomanualChanged)
# Security buttons and text
        self.sec_mirror_default = xml.get_widget("sec_mirror_default")
        self.sec_mirror_manually = xml.get_widget("sec_mirror_manually")
        self.security_host = xml.get_widget("security_host")
        self.volatile_host = xml.get_widget("volatile_host")
        self.sec_no_mirror = xml.get_widget("sec_no_mirror")
        self.use_security_updates = xml.get_widget("use_security_updates")
        self.security_host.connect("changed", self.secmanualChanged)
        self.volatile_host.connect("changed", self.secmanualChanged)
# Desktop toogle
        self.KDE_CheckButton.connect("toggled", self.desktop_toggled)
        self.Gnome_CheckButton.connect("toggled", self.desktop_toggled)
        self.Xfce_CheckButton.connect("toggled", self.desktop_toggled)
        self.xdm_radiobutton = xml.get_widget("xdm_radiobutton")
        self.gdm_radiobutton = xml.get_widget("gdm_radiobutton")
        self.kdm_radiobutton = xml.get_widget("kdm_radiobutton")
# Default options
        try:
            self.RP_NonFree.set_active(True)
            self.RP_Contrib.set_active(True)
            self.RP_Main.set_active(True)
            self.RP_Main.set_sensitive(False)
            self.RP_Backports.set_active(False)
            self.RP_Restricted.set_active(False)
            self.RP_Universe.set_active(False)
            self.Gnome_CheckButton.set_active(True)
            self.Standard.set_active(True)
            self.Standard.set_sensitive(False)
            self.mirror_list.set_active(True)
            self.sec_mirror_default.set_active(True)
            self.use_security_updates.set_active(True)
            select = self.repo_list.index("ftp.us.debian.org")
            self.repo_combo.list.select_item(select)
        except:
            select = 0

    def desktop_toggled(self,entry):
        status = self.KDE_CheckButton.get_active() or self.Gnome_CheckButton.get_active() or self.Xfce_CheckButton.get_active()
        self.config_x_button.set_active(status)
        self.xconfig_notebook.set_sensitive(status)
        self.xdm_radiobutton.set_sensitive(status)
        self.gdm_radiobutton.set_sensitive(self.Gnome_CheckButton.get_active())
        self.gdm_radiobutton.set_active(self.Gnome_CheckButton.get_active())
        self.kdm_radiobutton.set_sensitive(self.KDE_CheckButton.get_active())
        self.kdm_radiobutton.set_active(self.KDE_CheckButton.get_active())
        self.xdm_radiobutton.set_active(self.Xfce_CheckButton.get_active())

    def repolistChanged(self,entry):
        self.mirror_list.set_active(True)

    def repomanualChanged(self, entry):
        self.mirror_manually.set_active(True)

    def secmanualChanged(self, entry):
        self.sec_mirror_manually.set_active(True)

    def getData (self):

# Repositories checkbuttons
        buf = ""
        if self.RP_NonFree.get_active():
            buf = buf + "d-i apt-setup/non-free boolean true"
        else:
            buf = buf + "d-i apt-setup/non-free boolean false"

        if self.RP_Contrib.get_active():
            buf = buf + "\nd-i apt-setup/contrib boolean true"
        else:
            buf = buf + "\nd-i apt-setup/contrib boolean false"

        if self.RP_Backports.get_active():
            buf = buf + "\nd-i apt-setup/backports boolean true"

        if self.RP_Restricted.get_active():
            buf = buf + "\nd-i apt-setup/restricted boolean true"

        if self.RP_Universe.get_active():
            buf = buf + "\nd-i apt-setup/universe boolean true"

# Additional options


        if self.src_button.get_active():
            buf = buf + "\nd-i apt-setup/local0/source boolean true"
        else:
            buf = buf + "\nd-i apt-setup/local0/source boolean false"

# Multipackages checkbuttons
        buf = buf + "\ntasksel tasksel/first multiselect"
        if self.Standard.get_active():
            buf = buf + " standard"
        if self.FileServer.get_active():
            buf = buf + ", file server"
        if self.MailServer.get_active():
            buf = buf + ",  mail server"
        if self.SQLDatabase.get_active():
            buf = buf + ", sql database"
        if self.DNS.get_active():
            buf = buf + ", dns server"
        if self.Laptop.get_active():
            buf = buf + ", laptop"
        if self.PrintServer.get_active():
            buf = buf + ", print-server"
        if self.WebServer.get_active():
            buf = buf + ", web-server"
        if self.LAMP.get_active():
            buf = buf + ", lamp"

# Desktop Environment

        buf = buf + "\ntasksel tasksel/desktop multiselect "
        if self.Gnome_CheckButton.get_active():
            buf = buf + "desktop"
        if self.KDE_CheckButton.get_active():
            buf = buf + ", kde-desktop"
        if self.Xfce_CheckButton.get_active():
            buf = buf + ", xfce-desktop"

# Additional packages
        if self.AdPackages_Entry.get_text() != "":
            buf = buf + "\nd-i pkgsel/include string " + self.AdPackages_Entry.get_text()
# Update packages
        if self.NO_Update_button.get_active():
            buf = buf + "\nd-i pkgsel/upgrade select none"

        self.kickstartData.setpackages2([buf])

# Allow Unnautenticated
        buf_Unnautenticated = [""]
        if self.AllowUnnautenticated_CheckButton.get_active():
            buf_Unnautenticated.extend(["d-i debian-installer/allow_unauthenticated string true"])
        else:
            buf_Unnautenticated.extend(["d-i debian-installer/allow_unauthenticated string false"])

        self.kickstartData.setUnnautenticated(buf_Unnautenticated)

# Repository Selection
        buf_mirror = ""
#        buf_mirror = buf_mirror + "\n#Packages mirror information"
        if self.no_mirror.get_active():
           buf_mirror = buf_mirror + "d-i apt-setup/use_mirror boolean false"
        elif self.mirror_list.get_active():
            buf_mirror = buf_mirror + "d-i mirror/country string enter information manually"
            buf_mirror = buf_mirror + "\nd-i mirror/http/hostname string " + self.repo_combo.entry.get_text()
            buf_mirror = buf_mirror + "\nd-i mirror/http/directory string /debian"
            buf_mirror = buf_mirror + "\nd-i mirror/suite string etch"
            buf_mirror = buf_mirror + "\nd-i mirror/http/proxy string " + self.mirror_proxy.get_text()
        elif self.mirror_manually.get_active():
            buf_mirror = buf_mirror + "d-i mirror/country string enter information manually"
            buf_mirror = buf_mirror + "\nd-i mirror/http/hostname string " + self.mirror_hostname.get_text()
            buf_mirror = buf_mirror + "\nd-i mirror/http/directory string " + self.mirror_directory.get_text()
            buf_mirror = buf_mirror + "\nd-i mirror/suite string " + self.mirror_suite.get_text()
            buf_mirror = buf_mirror + "\nd-i mirror/http/proxy string " + self.mirror_proxy.get_text()
        else:
            buf_mirror = buf_mirror + "d-i mirror/country string enter information manually"
            buf_mirror = buf_mirror + "\nd-i mirror/http/hostname string " + self.repo_list[random.randint(0,42)]
            buf_mirror = buf_mirror + "\nd-i mirror/http/directory string /debian"
            buf_mirror = buf_mirror + "\nd-i mirror/suite string etch"
            buf_mirror = buf_mirror + "\nd-i mirror/http/proxy string " + self.mirror_proxy.get_text()

        self.kickstartData.setMirrors([buf_mirror])


# Security mirror
        buf_sec_mirror = ""
#        buf_sec_mirror = buf_sec_mirror + "\n#Security mirror information"
        if self.sec_mirror_default.get_active():
            buf_sec_mirror = buf_sec_mirror + "d-i apt-setup/services-select multiselect security, volatile"
            buf_sec_mirror = buf_sec_mirror + "\nd-i apt-setup/security_host string security.debian.org"
            buf_sec_mirror = buf_sec_mirror + "\nd-i apt-setup/volatile_host string volatile.debian.org"
        elif self.sec_no_mirror.get_active():
            buf_sec_mirror = buf_sec_mirror + "d-i apt-setup/security_host string "
            buf_sec_mirror = buf_sec_mirror + "d-i apt-setup/volatile_host string "
        else:
            buf_sec_mirror = buf_sec_mirror + "d-i apt-setup/services-select multiselect security, volatile"
            buf_sec_mirror = buf_sec_mirror + "\nd-i apt-setup/security_host string " + self.security_host.get_text()
            buf_sec_mirror = buf_sec_mirror + "\nd-i apt-setup/volatile_host string " + self.volatile_host.get_text()

        if self.use_security_updates.get_active():
            buf_sec_mirror = buf_sec_mirror + "\nbase-config apt-setup/security-updates boolean true"
        else:
            buf_sec_mirror = buf_sec_mirror + "\nbase-config apt-setup/security-updates boolean false"

        self.kickstartData.setSecMirrors([buf_sec_mirror])

        return 0

    def fillData(self):
        list = self.kickstartData.getpackages2()
